; TIP1152.LSP: TT.LSP    Trim Around Text   (c)1995, Larry Twilly
;                            $50 BONUS WINNER

;; Trims entities that cross thru selected text. 
;; Space between text and trimmed entity is controlled 
;; by "csize" and "tsize" based on the current LTSCALE.
;; Sometimes you must run tt.slp twice to trim all entities.
;; If no entites are erased or if entities (such as circles) 
;; are completely erased, adjust the LTSCALE or 
;; the csize and tsize factors noted below. 

(defun C:TT(/ TSIZE PSIZE ENT NUM CNT TEXTENT X Y TB SX SY L1 L2 L3 L4)
  (setq TSIZE (* 0.15 (getvar "LTSCALE")) ;;adjust 0.15 as required 
    CSIZE (* 0.17 (getvar "LTSCALE"))     ;;adjust 0.17 as required
    ENT (ssget)
    NUM (sslength ENT)
    CNT 0
  )
  (repeat NUM
    (setq TEXTENT (ssname ENT CNT) CNT (+ 1 CNT))
    (if (= "TEXT" (cdr (assoc 0 (entget (ssname ENT (- CNT 1))))))
      (progn
        (setq   TB (textbox (list (cons -1 TEXTENT)))
          SX (nth 1 (assoc 10 (entget TEXTENT)))
          SY (nth 2 (assoc 10 (entget TEXTENT)))
          ST (list SX SY)
          SR (cdr (assoc 50 (entget TEXTENT)))
          X  (+ (nth 0 (car TB))(nth 0 (cadr TB)))
          Y  (+ (nth 1 (car TB))(nth 1 (cadr TB)))
          C1 (polar ST (+ (* pi 1.25) SR) CSIZE)
          C2 (polar C1 SR (+ (* CSIZE 1.4) X))
          C4 (polar C1 (+ (* pi 0.5) SR) (+ (* CSIZE 1.4) Y))
          C3 (polar C2 (+ (* pi 0.5) SR) (+ (* CSIZE 1.4) Y))
          T1 (polar ST (+ (* pi 1.25) SR) TSIZE)
          T2 (polar T1 SR (+ (* TSIZE 1.4) X))
          T4 (polar T1 (+ (* pi 0.5) SR) (+ (* TSIZE 1.4) Y))
          T3 (polar T2 (+ (* pi 0.5) SR) (+ (* TSIZE 1.4) Y))
        )
        (command "line" C1 C2 "")
        (setq L1 (entlast))
        (command "line" C2 C3 "")
        (setq L2 (entlast))
        (command "line" C3 C4 "")
        (setq L3 (entlast))
        (command "line" C4 C1 "")
        (setq L4 (entlast))
        (command "trim" L1 L2 L3 L4 "" "f" T1 T2 T3 T4 T1 T3 T4 T2 "" "")
        (command "erase" L1 L2 L3 L4 "")
      )
    )
  )
); end tt.lsp
